ScriptExt
Date: 2019-10-22

org.jmol.scriptext

## Class ScriptExt

- java.lang.Object
- - org.jmol.scriptext.ScriptExt

- Direct Known Subclasses:
    CmdExt, IsoExt

      public abstract class ScriptExt
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `chk`
    `protected ScriptEval` | `e`
    `protected int` | `slen`
    `protected T[]` | `st`
    `protected Viewer` | `vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ScriptExt()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected javajs.util.BS` | `atomExpressionAt(int i)`
    `protected javajs.util.P3` | `centerParameter(int i)`
    `protected void` | `checkLength(int i)`
    `abstract java.lang.String` | `dispatch(int iTok, boolean b, T[] st)`
    `protected void` | `error(int err)`
    `protected void` | `finalizeObject(int shapeID, int colorArgb, float translucentLevel, int intScale, boolean doSet, java.lang.Object data, int iptDisplayProperty, javajs.util.BS bs)`
    `protected float` | `floatParameter(int i)`
    `protected javajs.util.P3[]` | `getAllPoints(int index)`
    `protected float` | `getColorTrans(ScriptEval eval, int i, boolean allowNone, int[] ret)` Checks color, translucent, opaque parameters.
    `protected int[][]` | `getIntArray2(int i)`
    `protected javajs.util.P3` | `getPoint3f(int i, boolean allowFractional)`
    `protected java.lang.Object` | `getShapeProperty(int shapeType, java.lang.String propertyName)`
    `protected T` | `getToken(int i)`
    `ScriptExt` | `init(java.lang.Object eval)`
    `protected int` | `intParameter(int index)`
    `protected void` | `invArg()`
    `protected void` | `invPO()`
    `protected boolean` | `isFloatParameter(int index)`
    `protected java.lang.String` | `paramAsStr(int i)`
    `protected java.lang.String` | `setShapeId(int iShape, int i, boolean idSeen)`
    `protected void` | `setShapeProperty(int shapeType, java.lang.String propertyName, java.lang.Object propertyValue)`
    `protected void` | `showString(java.lang.String s)`
    `protected java.lang.String` | `stringParameter(int index)`
    `protected int` | `tokAt(int i)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### vwr

          protected Viewer vwr

    - #### e

          protected ScriptEval e

    - #### chk

          protected boolean chk

    - #### st

          protected T[] st

    - #### slen

          protected int slen

  - ### Constructor Detail

    - #### ScriptExt

          public ScriptExt()

  - ### Method Detail

    - #### init

          public ScriptExt init(java.lang.Object eval)

    - #### dispatch

          public abstract java.lang.String dispatch(int iTok,
                                                    boolean b,
                                                    T[] st)
                                             throws ScriptException

      Throws:
        `ScriptException`

    - #### atomExpressionAt

          protected javajs.util.BS atomExpressionAt(int i)
                                             throws ScriptException

      Throws:
        `ScriptException`

    - #### checkLength

          protected void checkLength(int i)
                              throws ScriptException

      Throws:
        `ScriptException`

    - #### error

          protected void error(int err)
                        throws ScriptException

      Throws:
        `ScriptException`

    - #### invArg

          protected void invArg()
                         throws ScriptException

      Throws:
        `ScriptException`

    - #### invPO

          protected void invPO()
                        throws ScriptException

      Throws:
        `ScriptException`

    - #### getShapeProperty

          protected java.lang.Object getShapeProperty(int shapeType,
                                                      java.lang.String propertyName)

    - #### paramAsStr

          protected java.lang.String paramAsStr(int i)
                                         throws ScriptException

      Throws:
        `ScriptException`

    - #### centerParameter

          protected javajs.util.P3 centerParameter(int i)
                                            throws ScriptException

      Throws:
        `ScriptException`

    - #### floatParameter

          protected float floatParameter(int i)
                                  throws ScriptException

      Throws:
        `ScriptException`

    - #### getPoint3f

          protected javajs.util.P3 getPoint3f(int i,
                                              boolean allowFractional)
                                       throws ScriptException

      Throws:
        `ScriptException`

    - #### intParameter

          protected int intParameter(int index)
                              throws ScriptException

      Throws:
        `ScriptException`

    - #### isFloatParameter

          protected boolean isFloatParameter(int index)

    - #### setShapeProperty

          protected void setShapeProperty(int shapeType,
                                          java.lang.String propertyName,
                                          java.lang.Object propertyValue)

    - #### showString

          protected void showString(java.lang.String s)

    - #### stringParameter

          protected java.lang.String stringParameter(int index)
                                              throws ScriptException

      Throws:
        `ScriptException`

    - #### getToken

          protected T getToken(int i)
                        throws ScriptException

      Throws:
        `ScriptException`

    - #### tokAt

          protected int tokAt(int i)

    - #### setShapeId

          protected java.lang.String setShapeId(int iShape,
                                                int i,
                                                boolean idSeen)
                                         throws ScriptException

      Throws:
        `ScriptException`

    - #### getColorTrans

          protected float getColorTrans(ScriptEval eval,
                                        int i,
                                        boolean allowNone,
                                        int[] ret)
                                 throws ScriptException

      Checks color, translucent, opaque parameters.
      Parameters:
        `eval` -
        `i` -
        `allowNone` -
        `ret` - returned int argb color
      Returns:
        translucentLevel and sets iToken and ret[0]
      Throws:
        `ScriptException`

    - #### finalizeObject

          protected void finalizeObject(int shapeID,
                                        int colorArgb,
                                        float translucentLevel,
                                        int intScale,
                                        boolean doSet,
                                        java.lang.Object data,
                                        int iptDisplayProperty,
                                        javajs.util.BS bs)
                                 throws ScriptException

      Throws:
        `ScriptException`

    - #### getIntArray2

          protected int[][] getIntArray2(int i)
                                  throws ScriptException

      Throws:
        `ScriptException`

    - #### getAllPoints

          protected javajs.util.P3[] getAllPoints(int index)
                                           throws ScriptException

      Throws:
        `ScriptException`